#pragma once

#include <string>
#include "boost/program_options.hpp"

#include "core/log/Log.h"
typedef Core::Log Log;

#pragma warning( disable: 4482 ) //explicit enum


class Config
{
  private:
    static boost::program_options::variables_map s_vm;

  public:

    Config(void);
    ~Config(void);

    template< typename T > static const T get( const std::string _id )
    {
      if( s_vm.count(_id) )
      {
        try
        {
          T value = s_vm[_id].as<T>();
          LOG_INFO << "Config::get( " << _id << " ) - ( " << value << " )\n";
          return value;
        }
        catch(std::exception& e)
        {
            LOG_ERROR << "Config::get( " << _id << " ) - ( " << e.what() << " )\n";
        }    
      }

      LOG_ERROR << "Config::get( " << _id << " ) - NOT FOUND\n";
      return T();
    }
};
