#ifndef CORE_OUTPUTFILE_H_
#define CORE_OUTPUTFILE_H_

#include <fstream>
#include <sstream>

namespace Core
{

class OutputFile
{
private:
  std::ofstream m_file;
public: 
  OutputFile( std::string _filename )
  {
    m_file.open( _filename.c_str(), std::ios::out | std::ios::trunc );
  }

  ~OutputFile()
  {
    m_file.close();
  }

  void flush()
  {
    m_file.flush();
  }

  friend std::ostream& operator<<( OutputFile& _file, const std::ostringstream& _stream );
};

}; //Core


#endif //CORE_OUTPUTFILE_H_
