#include "BinarySerializer.h"


namespace Core
{



};

using namespace Core;

#ifdef _VECSERIAL

RakNet::BitStream& operator << (RakNet::BitStream& out, BinarySerializer& in)
{
  SerializeBuffer::const_iterator it = in.buffer().begin();
  const unsigned size = in.buffer().size();

  out.Write( size );

  for(; it != in.buffer().end(); it++)
  {
    const SerializeBufferElem cache = (*it);
    out.Write( (*it) );
  }
  return out;
}

RakNet::BitStream& operator >> (RakNet::BitStream& in, BinaryDeserializer& out)
{
  unsigned size;
  in.Read( size );

  out.buffer().reserve( size );

  for(unsigned i = 0; i < size; i++)
  {
    SerializeBufferElem cache;
    in.Read( cache );
    out.buffer().push_back( cache );
  }

  return in;
}

#else

#include "config.h"

RakNet::BitStream& operator << (RakNet::BitStream& out, BinarySerializer& in)
{
  in.flush();

  out.Write( in.size() );

  std::string string = in.str();

  for ( std::string::iterator it = string.begin() ; it != string.end(); it++ )
  {
    const char cache = *it;
    out.Write( cache );
  }

  return out;
}

RakNet::BitStream& operator >> (RakNet::BitStream& in, BinaryDeserializer& out)
{
  unsigned size;
  in.Read( size );

  std::string string;

  for ( unsigned i = 0; i < size; i++ )
  {
    char cache;
    in.Read( cache );
    string.append( 1, cache );
  }

  out.str( string );

  return in;
}

RakNet::BitStream& operator >> (RakNet::BitStream& in,  std::stringstream& out)
{
  unsigned size;
  in.Read( size );

  std::string string;

  for ( unsigned i = 0; i < size; i++ )
  {
    char cache;
    in.Read( cache );
    string.append( 1, cache );
  }

  out.str( string );

  return in;
}

#endif