#ifndef CORE_DIRECTION_H_
#define CORE_DIRECTION_H_

#include "core/types/Vector2d.h"

namespace Core {

class Direction
{
  public:
    enum eDirection
    {
      INVALID = 0,
      UP,
      DOWN,
      LEFT,
      RIGHT
    };

  public:
    Direction( eDirection _value ) :
      m_value( _value ) {}

    Int2d toOffset() const;
    void rotate  ();

    const eDirection& value() const { return m_value; };
    eDirection& value()             { return m_value; };

    template<class Serializer>
    void serialize( Serializer& _s, const unsigned int _version )
    {
      _s & m_value;
    }


  private:
    eDirection m_value;
};

}; //Core

#endif //CORE_DIRECTION_H_
