#include "DataKernel.h"

#include "data/world/World.h"

using namespace Data;


DataKernel::DataKernel( Core::CoreKernel& _coreKernel, Network::NetworkKernel& _networkKernel ) :
  m_coreKernel( _coreKernel ),
  m_networkKernel( _networkKernel )
{
  init();
}

DataKernel::~DataKernel(void)
{
  deinit();
}


void
DataKernel::init()
{
  World::init();
}

void
DataKernel::deinit()
{
  World::deinit();
}

void
DataKernel::reset()
{
  deinit();
  init();
}

void
DataKernel::update( const float _secs )
{
  m_coreKernel.update( _secs );
  m_networkKernel.update( _secs );

  World::update( _secs );
}
