#pragma once

#include "core/CoreKernel.h"
#include "network/NetworkKernel.h"

namespace Data {

class DataKernel
{
  public:
    DataKernel( Core::CoreKernel& _coreKernel, Network::NetworkKernel& _networkKernel );
    ~DataKernel(void);

    void update( const float _secs );

  private:
    static void reset();
    static void init();
    static void deinit();

private:
    Core::CoreKernel&         m_coreKernel;
    Network::NetworkKernel&   m_networkKernel;
};

}; //Data