#include "RenderKernel.h"

#include "Drawable.h"

#include <set>

namespace Render
{
typedef std::set<Drawable*> Drawables;
Drawables s_drawables;

}; // Render



using namespace Render;

RenderKernel::RenderKernel( Data::DataKernel& _dataKernel ) :
  m_dataKernel( _dataKernel )
{
}

RenderKernel::~RenderKernel(void)
{
}

void
RenderKernel::registerObject( Drawable* _object )
{
  if( _object )
  {
    s_drawables.insert( _object );
  }
}

void
RenderKernel::unregisterObject( Drawable* _object )
{
  if( _object )
  {
    s_drawables.erase( _object );
  }
}


void
RenderKernel::update( const float _secs )
{
  //no need to update data, because logic will update it

  Drawables::iterator it;
  for( it = s_drawables.begin(); it != s_drawables.end(); ++it)
  {
    (*it)->draw( _secs );
  }
}
