#include "Animation.h"

#include "DarkGDK.h"

using namespace Render;
using Core::Ressources;

Animation::Animation( Ressources::Sprite _sprite )
: Sprite( _sprite )
{
}

Animation::~Animation(void)
{
  Sprite::~Sprite();
}

void
Animation::animate( const unsigned _start, const unsigned _end, const unsigned _delay ) const
{
  int frame = dbSpriteFrame( m_spriteId );
  if( frame < _start || frame > _end )
  {
    dbSetSpriteFrame( m_spriteId, _start );
  }

  dbPlaySprite ( m_spriteId, _start, _end, _delay );
}
