#pragma once

#include "render/Drawable.h"
#include "render/base/Animation.h"

namespace Data
{
  class Creature;
}

namespace Render {

class Creature : public Drawable
{
public:
  Creature( const Data::Creature* _data );
  virtual ~Creature(void);

  static Creature* getRenderByData( const Data::Creature* _data );

  void updatePosition() const;
  void animateCreature() const;

  virtual void draw( const float& _secs );

private:
  const Data::Creature* m_data;
  Animation             m_sprite;
};

}; //Render